--require "basementpath"
require "Basement"

function Process_Drivers(dstdir, updatefiles, isupdate)
	local os 		= ATM_LoadTempData("OS");
	local bits		= ATM_LoadTempData("BITs");

	-- confirm drvdir and ndisdir
	local drvdir	= string.format("%s\\32", dstdir);
	if bits == "64-bit" then
		 drvdir  = string.format("%s\\64", dstdir);
	end

	local ndisdir	= drvdir
	local arpdir    = drvdir
	local ndiscmd 	= string.format(" -c s -l \"%s\\esmndis.inf\"  -p \"%s\\esmndis_m.inf\" -i RS_ESMNDIS", ndisdir, drvdir);		-- v5
	local arpcmd    = string.format(" -l \"%s\\esmarp.inf\" -c p -i RS_ESMARP", drvdir); -- v5
	if (os == "Windows XP" or os == "Server 2003") then -- v5
		-- do nothing
	elseif (os == "Vista" or os == "Server 2008" or os == "Server 2008 R2" or os == "Windows 7") then --v6
		ndisdir	= string.format("%s\\NT6", drvdir)
		arpdir	= string.format("%s\\NT6", drvdir)
		ndiscmd = string.format(" -c s -l \"%s\\esmndis.inf\" -i RS_ESMNDIS", ndisdir);
		arpcmd    = string.format(" -l \"%s\\esmarp.inf\" -c p -i RS_ESMARP", arpdir);
	elseif (os == "Windows 8") then
		-- fwbase drivers don't support window 8
		return
	else
		donelastop 	= false;
	end
	
	-- get updated information about drivers
	local updated = {esmndis = false, esmtdi = false, esmdrv = false, esmarp = false};
	if isupdate then
		for file, status in pairs(updatefiles) do
			if 		file == "esmdrv.dll"  or file == "esmdrv.sys" 	then	updated["esmdrv"]  = true
			elseif	file == "esmarp.dll"  or file == "esmarp.sys" 	then	updated["esmarp"]  = true
			elseif	file == "esmtdi.sys"							then	updated["esmtdi"]  = true
			elseif	file == "esmndis.sys"							then	updated["esmndis"] = true
			end
		end
	else
		updated = {esmndis = true, esmtdi = true, esmdrv = true, esmarp = true};
	end

	--[[ 
	ǽΪ : ײ ndis arp tid  ϲΪ esmdrv 
	[]
	ʾ
	[]
	1. Ҫֹͣ esmdrv 
	2. arp ndis tdi ֻҪļ OK ˣҪЧ
	3. esmdrv ޸ıȽ϶࣬ķ
	[ж]
	ʾ
	--]]

	if updated["esmdrv"] == false and updated["esmtdi"] == false and updated["esmarp"] == false and updated["esmndis"] == false then
		return;
	end
	
	-- 1. stop esmdrv service
	TSA_StopService("esmdrv", string.format("%s\\esmdrv.sys", drvdir));
	
	-- 2. install service or drivers
	local snethelp = string.format("%s\\snetcfg.exe", drvdir)
	if (updated["esmdrv" ] or not Service.IsExistedService('esmdrv')) and donelastop then
		TSA_UninstallService("esmdrv", string.format("%s\\esmdrv.sys", drvdir));
		TSA_InstallService("esmdrv", "Rising ESMDrv driver", string.format("%s\\esmdrv.sys", drvdir), true);
	end
	if (not Service.IsExistedService('esmtdi')) and donelastop then
		--[[ tid driver can't stop, we just copy file when update --]]
		TSA_InstallService("esmtdi", "Rising ESMTdi Driver", string.format("%s\\esmtdi.sys", drvdir), true);
	end
	if (not Service.IsExistedService('esmarp')) and donelastop then
		ATM_Execute(snethelp, arpcmd, {0, 0x4a020}, true);
	end
	if (not Service.IsExistedService('esmndis')) and donelastop then
		ATM_Execute(snethelp, ndiscmd, {0, 0x4a020}, true);
	end
	
	-- 3. start esmdrv service
	TSA_StartService("esmdrv");
	
	-- 4. if update nis tdi arp and not in slience mode, we will notify user restart computer.
	if isupdate then
		if updated["esmtdi"] == true or updated["esmndis"] == true or updated["esmarp"] == true then
			local cmd = winfunc.GetCmdLine();
			cmd = string.lower(cmd)
			if string.find(cmd, "tray") or string.find(cmd, "silence") then
				donerestart = true
				return
			end
		end
	end
end



function is_network_restart(categoryfile, srcdir, destdir)
	donelastop = true
	
	-- I. load category
	local category 	= LoadCategory(string.format("%s\\%s", srcdir, categoryfile));
	if not TrackOp(#category > 0, VerifyResult, string.format("get file list from category file [%s\\%s]", srcdir, categoryfile)) then
	    donelastop = false;
		return false;
	end
	local oldcategory = {}
	if FileSys.PathFileExists(string.format("%s\\%s", destdir, categoryfile)) then
		oldcategory = LoadCategory(string.format("%s\\%s", destdir, categoryfile));
	end

	-- II. justy tdi driver
    for index, target in pairs(category) do
		if target['name'] == 'esmtdi.sys' then
			src = string.format('%s\\%s\\%s', srcdir,  target['path'], target['name']);
			dst = string.format('%s\\%s\\%s', destdir, target['path'], target['name']);

			-- match md5
			local src_md5 = MD5.CheckSumFile_MD5(src);
			if not (src_md5 == target['checksum']) then
				RecordErrOp ("FAILED TO", string.format("mismatch checksum of file[%s]", target['name']))
				donelastop = false;
				return false;
			end

			--  if source and destination aren't same, show network restart tip.
			local dst_md5 = MD5.CheckSumFile_MD5(dst);
			if dst_md5 ~= src_md5 or not Service.IsExistedService('esmtdi') then
				-- if the setup.exe run in session 0, the message box can't show.
				local cmd 		= winfunc.GetCmdLine();
				cmd = string.lower(cmd)
				if string.find(cmd, "sys") then
					RecordErrOp("WARNING TO", "Session 0, we don't do install fwbase");
					donelastop = false;
					return false
				end
		
				if not TSA_ContinueConfirm(g_ParentHwnd, "ҵն˰ȫϵͳ", "ϵͳҪǷ", "", "ֹ") then
					RecordErrOp("WARNING TO", "ûȡװ");
					donelastop = false;
					doneabort = true;
					return false;
				end
			end
			return donelastop
		end
	end
	return donelastop;
end

function real_update(srcdir, rootdir, update)
	local dstdir 	= string.format('%s\\%s', rootdir, component['name']);
	
	--[[
	because install tdi driver will restart network, so we must notify the user before install.
	--]]
	is_network_restart(component['category'], srcdir, dstdir);
	if donelastop == false then
		return;
	end

	--[[ 
	stop "esmep" and "epsrv" service. 
	--]]
	for srvname, srvfile in pairs(component['svcname']) do
		TSA_StopService(srvname, string.format("%s\\%s", dstdir, srvfile));
	end

	local drvfiles = {"esmdrv.dll", "esmdrv.sys", "esmarp.sys", "esmarp.dll", "esmndis.sys", "esmtdi.sys"};
	-- copy necessary files
	TSA_UpdateComponentFiles(component['category'], srcdir, dstdir, update, drvfiles);
	TSA_InstallComponetConfigToEP (component['name'], srcdir, string.format("%s\\ep", rootdir));

	-- install drives
	Process_Drivers(dstdir, g_WatchedFileUpdate, update);
end


function install (srcdir, rootdir)
	real_update(srcdir, rootdir, false);
end


function update (srcdir, rootdir)
	real_update(srcdir, rootdir, true);
end


function collectparam (srcdir, rootdir)
	-- do nothing
end


function uninstall (srcdir, rootdir)
	local dstdir 	= string.format('%s\\%s', rootdir, component['name']);
	
	--[[ 
	1. stop "esmep" and "epsrv" service. 
	--]]
	for srvname, srvfile in pairs(component['svcname']) do
		TSA_StopService(srvname, string.format("%s\\%s", dstdir, srvfile));
	end
	
	--[[
	2. uninstall fwbase
	--]]
	
	local os 		= ATM_LoadTempData("OS");
	local bits		= ATM_LoadTempData("BITs");
	local drvdir	= string.format("%s\\32", dstdir);
	if bits == "64-bit" then
		 drvdir  = string.format("%s\\64", dstdir);
	end

	for svcname, svcfile in pairs({esmdrv = 'esmdrv.sys'}) do
		TSA_UninstallService(svcname, string.format("%s\\%s", drvdir, svcfile));
		donelastop = true;
	end

	--[[ 
	uninstall ESMARP and ESMNDIS drivers
	--]]
	local bUninstallOk = true;
	for uid, did in pairs({RS_ESMARP = 'ESMARP', RS_ESMNDIS = 'ESMNDIS'}) do
		local bUninstall = ATM_Execute(string.format("%s\\snetcfg.exe", drvdir), string.format(" -u %s -d %s", uid, did),   {0}, true);
		-- if uninstall failed, we should delete remain files by manual.
		if bUninstall == false then
			bUninstallOk = false;
			-- delete esmarp.sys and esmndis.sys in dir : C:\WINDOWS\system32\drivers
			local sysdir = WinDir.PathProviderWin(WinDir.DIR_SYSTEM);
			local drvfile = string.format("%s\\drivers\\%s.sys", sysdir.c_str(), did);
			ATM_DelPath(drvfile);
			
			-- delete esmarp and esmndis in registry : HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\ESMARP
			ATM_RemoveRegKeyEx("HKEY_LOCAL_MACHINE", "SYSTEM\\CurrentControlSet\\services", did);
		end
		donelastop  = true;
		donerestart = true;
	end
	if bUninstallOk == false then
		-- delete oem*.inf oem*.PNF in dir : C:\WINDOWS\inf 
		-- delete and oem*.cat  in dir : C:\WINDOWS\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}
		local windir = WinDir.PathProviderWin(WinDir.DIR_WINDOWS)
		local infdir = string.format("%s\\inf\\oem*.inf", windir.c_str())
		local bFindFile = FileFind.FindFile(infdir, 0)
		while bFindFile == true do
			bFindFile = FileFind.FindNextFile();
			local inffile = tostring(FileFind.GetFilePath());
			--winfunc.msgbox(inffile)
			local provider = tostring(WinIni.GetIniString(inffile, "version", "Provider"));
			--winfunc.msgbox(provider)
			if provider == "%Rsft%" then
				--winfunc.msgbox(inffile)
				local oemtitle = tostring(FileFind.GetFileTitle());
				local pnffile = string.format("%s\\inf\\%s.PNF", tostring(windir), oemtitle)
				--winfunc.msgbox(pnffile)
				local catfile = string.format("%s\\system32\\CatRoot\\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}\\%s.CAT", tostring(windir), oemtitle);
				--winfunc.msgbox(catfile);
				ATM_DelPath(pnffile);
				ATM_DelPath(inffile);
				ATM_DelPath(catfile);
				donelastop = true;
			end
		end
	end
	
	--[[
	uninstall ESMTDI drivers
	--]]
	ATM_RemoveRegKeyEx("HKEY_LOCAL_MACHINE", "SYSTEM\\CurrentControlSet\\services", "esmtdi");
	
	TSA_RemoveComponentFiles(dstdir);
    donelastop = true;
	
	--[[
	restart "esmep" and "epsrv" service. 
	--]]
	for srvname, srvfile in pairs(component['svcname']) do
		TSA_StartService(srvname);
	end
end


function run (srcdir, rootdir)
	TSA_StartService("esmdrv");
	TSA_StartService("esmtdi");
	--[[
	esmep will start other service auto.
	--]]
	TSA_StartService("esmep");
end


component = {name		= 'fwbase',
			 svcname 	= {esmep = 'esm.exe', epsrv = 'epsrv.exe'},
			 category	= 'fwbase.xml',
			 role 		= 'library'
			};
