--require "basementpath"
require "Basement"


function real_update(srcdir, rootdir, update)
	-- verify whether src version is higher dest's
	local dstdir 	= string.format('%s\\%s', rootdir, component['name']);
    local m			= ATM_VerifyVersion(component['category'], srcdir, dstdir);

	if (m == EQ and not TSA_ContinueConfirm("汾ͻ", string.format("updating with same version of product [%s], continue or not", component['name'])))
		or (m == HI and not TSA_ContinueConfirm("汾ͻ", string.format("updating with lower version of product [%s], continue or not", component['name'])))
	then
		return;
	end

	-- remov webmon from rba at 27.7.2012
	if FileSys.PathFileExists(string.format("%s\\WebMon.dll",dstdir)) and donelastop then
		TSA_ProcessWebmonBHO(dstdir, false);
		donelastop = true						-- avoid terminated by failure of uninstallation of webmon
	end
	TSA_UpdateComponentFiles	  (component['category'], srcdir, dstdir, update);
	TSA_InstallComponetConfigToEP (component['name']    , srcdir, string.format("%s\\ep", rootdir));
	TSA_InstallComponetPolicytoEp ("5f5d299f-1ef6-4573-9268-ed956b8ee2a1_1.policy", dstdir, string.format("%s\\ep", rootdir))
	TSA_InstallComponetPolicytoEp ("5f5d299f-1ef6-4573-9268-ed956b8ee2a1_3.policy", dstdir, string.format("%s\\ep", rootdir))
	--[[
	TSA_ProcessLSP(dstdir, true);
	--]]
end

function install (srcdir, rootdir)
	real_update(srcdir, rootdir, false);
end


function update (srcdir, rootdir)
	real_update(srcdir, rootdir, true);
end


function collectparam (srcdir, rootdir)
	-- do nothing
end


function uninstall (srcdir, rootdir)
	local dstdir = string.format('%s\\%s', rootdir, component['name']);

	-- Ϊͻ EP, ֹͣ ESMEP  EPTray
	TSA_StopService('esmep', string.format("%s\\ep\\esm.exe", rootdir));
	TSA_StopService('epsrv', string.format("%s\\ep\\epsrv.exe", rootdir));
	ATM_ExitProcessDuration(string.format("%s\\ep\\eptray.exe", rootdir), 60);
    donelastop = true;

	--TSA_ProcessLSP(dstdir, false);
	donelastop = true;

	-- remov webmon from rba at 27.7.2012
	if FileSys.PathFileExists(string.format("%s\\WebMon.dll",dstdir)) and donelastop then
		TSA_ProcessWebmonBHO(dstdir, false);
		donelastop = true						-- avoid terminated by failure of uninstallation of webmon
	end
	donelastop = true;
    TSA_RemoveComponentFiles(dstdir);
	donelastop = true;

	TSA_UninstallComponetConfigUnderEP (component['name'], string.format("%s\\ep", rootdir))
	donelastop = true;

	TSA_UninstallComponetPolicyToEp ( "5f5d299f-1ef6-4573-9268-ed956b8ee2a1_1.policy", string.format("%s\\ep", rootdir) )
	donelastop = true;
	TSA_UninstallComponetPolicyToEp ( "5f5d299f-1ef6-4573-9268-ed956b8ee2a1_3.policy", string.format("%s\\ep", rootdir) )
	donelastop = true;
end


function run (srcdir, rootdir)
	-- do nothing
end



component = {name='rba', category='rba.xml', role = 'monitor'};


