require "Basement"

function real_install(srcdir, rootdir, update)
	-- verify whether src version is higher dest's
	local dstdir = string.format('%s\\%s', rootdir, component['name']);
    local m = ATM_VerifyVersion(component['category'], srcdir, dstdir);

	if (m == EQ and not TSA_ContinueConfirm("汾ͻ", string.format("updating with same version of product [%s], continue or not", component['name'])))
		or (m == HI and not TSA_ContinueConfirm("汾ͻ", string.format("updating with lower version of product [%s], continue or not", component['name'])))
	then
		return;
	end

	for index, svcname in pairs(component['dependsvcs']) do
		TSA_StopService(svcname, string.format("%s\\%s\\esm.exe", rootdir, index));
	end

--	ATM_Execute(string.format("%s\\WindowsInstaller-KB884016-v2-x86.exe", srcdir), " /passive", {0}, true);
	if FileSys.PathFileExists(string.format("%s\\vcredist_x86.exe", srcdir)) then
		ATM_Execute(string.format("%s\\vcredist_x86.exe", srcdir), string.format("\"%s\\vcredist_x86.exe\" /q /l \"%s\\vcregistlog.txt\"", srcdir, srcdir), {0, 3010, 259}, true);
	end
	--[[ ʱװ vcredist_x86.exe ĳЩϻᷢԴֵ --]]
	-- [[ֲܰװ --]]
	--if update then
	donelastop = true;
	--end

	TSA_UpdateComponentFiles(component['category'], srcdir, dstdir);
end


function install (srcdir, rootdir)
	return real_install(srcdir, rootdir, false);
end


function update (srcdir, rootdir)
	return real_install(srcdir, rootdir, true);
end


function uninstall (srcdir, rootdir)
    TSA_RemoveComponentFiles(string.format('%s\\%s', rootdir, component['name']));

	for index, tablename in pairs({"CollectedParams", "imported_params"}) do
		local list = ATM_LoadTempData(tablename)
		for i, k in pairs(list) do
			ATM_DelTempData(k);
		end
		ATM_DelTempData(tablename);
	end

	for i, k in pairs({'install_package', 'showsubprocess_mode', 'OS', 'BITs'}) do
		ATM_DelTempData(k)
	end

    donelastop = true;
end


function collectparam (srcdir, rootdir)
	-- صļ
	local cmd = winfunc.GetCmdLine();

	local _, _, script = string.find(cmd.lower(cmd), "/tempcfg:\"([^\"]*)\"");
	local collected = {['CollectedParams'] = {}};
	if TrackOp(FileSys.PathFileExists(script), VerifyResult, string.format("find configuration file indicated by tempcfg[%s]", tostring(script))) then
		local f = io.open(script, "r");
		if not TrackOp(f ~= nil, VerifyResult, string.format("open config file[%s]", script)) then
			donelastop = false;
			return;
		end

		local s = tostring(f:read("*a"));
		if not TrackOp(	pcall(function () collected = loadstring(string.format("return %s", s))() end),
					    VerifyResult, string.format("load configuration[%s: length=%d]", script, string.len(s))
					   )
		then
			collected = {['CollectedParams'] = {}};
		end
		f:close();
	end


	local _, _, zipfile = string.find(cmd.lower(cmd), "/zip:\"([^\"]*)\"");
	if zipfile ~= nil then
		ATM_SaveTempData("install_package", zipfile);
	end


	-- set whether subprocess will be created with command line window
	local showmode = string.find(cmd.lower(cmd), "/showsubprocess") ~= nil;
	ATM_SaveTempData("showsubprocess_mode", showmode);

	local collectedparams = {}
	local imported_params = {};
	for key, val in pairs(collected['CollectedParams']) do
		collectedparams[key] = val
		ATM_SaveTempData(string.format("tempcfg_%s", tostring(key)), collected[key]);
		table.insert(imported_params, string.format("tempcfg_%s", tostring(key)));
	end


	--  quick mode
	local interactmode = CheckSPLMode(string.format("%s\\SPL.xml", rootdir));
	if interactmode == 'quick' then
		local localips = winfunc.GetValidIPs();
		if not TrackOp(type(localips) == 'string' and localips ~= "", VerifyResult, "fetch any valid host IPs(v4)") then
			TSA_ErrorReport("Error Report", "Installation failed with following errors", {"Fetch local IPs under Quick Mode"});
		else
			local selectedip = TSA_ComboIPCollect(g_ParentHwnd, "ֶIP, ΪѡһȷıIP", localips);
			for key, val in pairs({	EP_LINK 			= {text = selectedip, attributes = {Port = 5555}},
									BUS_LINK 			= {text = selectedip, attributes = {Port = 3333}},
									MANAGER_SVCPORT		= {text = 3333},
									BUS_SVCPORT			= {text = 5555},
									RUC_SVCPORT			= {text = 6666},
									MANAGER_WEBSITE		= {porthttp = 80, porthttps = 443, domain = selectedip, websitetype = "httpsonly"},
									RUC_WEBSITE			= {porthttp = 80, porthttps = 443, domain = selectedip, websitetype = "httponly"},
									RDC_WEBSITE			= {porthttp = 80, porthttps = 443, domain = selectedip, websitetype = "httponly"},
									RDC_DownLoadFolder	= string.format("%s\\..\\rdc\\download", srcdir)
								   }
								  )
			do
				ATM_SaveTempData(string.format("quick_%s", tostring(key)), val);
				collectedparams[key] = 1
				table.insert(imported_params, string.format("quick_%s", tostring(key)));
			end
		end
	end
	ATM_SaveTempData('CollectedParams', collectedparams);
	ATM_SaveTempData("imported_params", imported_params);

	-- ¼ϵͳϢ
	local osinfo 	= winfunc.GetSystemInfo();
	local _, _, osver, bits = string.find(osinfo, "([^,]+),(.+)")
	ATM_SaveTempData('OS',   osver)
	ATM_SaveTempData('BITs', bits)
end


function run (modedescription, preservedarg)
	if modedescription ~= "update" then
		return;
	end

	local svr  = tonumber(ATM_LoadTempData("ServerComponent") or 0);
	local bits = ATM_LoadTempData('BITs')
	if svr == 0 and bits ~= "64-bit" then
		TSA_StartService('hookesm');
	end

	for index, svcname in pairs(component['dependsvcs']) do
		if Service.IsExistedService(svcname) then
			TSA_StartService(svcname);
			donelastop = true;
		end
	end
end


component = {name	 	= 'common files',
			 category	= 'common files.xml',
			 dependsvcs = {ruc = 'esmruc', manager = 'esmmanager', ep = 'esmep', bus = 'esmbus', rsm = 'esmrsm', rdc = 'esmrdc'},
			 role		= 'library'};



